<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Common\Api;

class BaseApi {

    /**
     * 订单状态改变，在支付成功后
     * @param array $data ['ddh'=>订单号,'fee'=>金额,'qudao'=>渠道,'method'=>'post or get','back'=>【1代表返回路径】]
     */
    public function changeDingdan($data) {
        global $publicData;
        $peizhi = $publicData['peizhi'];

        //判断订单是否已经支付
        $dingdan = SM('Dingdan');
        $ddBuffer = $dingdan->findData('*', 'ordermd5="' . $data['ddh'] . '"');
        if (!$ddBuffer) {
            return [
                0,
                'no order in db'];
        }
        $money1 = number_format($ddBuffer['totalmoney'], 2, ".", "");
        $money2 = number_format($data['fee'], 2, ".", "");
        if ($money1 != $money2) {
            return [
                0,
                'pay money diff'];
        }

        if ($ddBuffer['status'] == 0) {
            $userBuffer = SM('User')->findData('*', 'userid="' . $ddBuffer['userid'] . '"');
            if ($userBuffer['agent'])
                $agentBuffer = SM('User')->findData('*', 'userid="' . $userBuffer['agent'] . '"');

            $dingdan->dbStartTrans(); //开始事务
            $flag = true; //事务标志
            $status = 1;
            $money = 0; //商户金额
            $dlmoney = 0; //代理金额
            //获取商户扣量信息
            if (($peizhi['ifkl'] != 1 && $userBuffer['ifkl'] == -1) || $userBuffer['ifkl'] == 0) {
                $money = $ddBuffer['havemoney'];
                $dlmoney = $ddBuffer['dailimoney'];
            } else {
                $zijianBuffer = SM('Zijian')->findData('*', 'userid=' . $ddBuffer['userid']);
                if (!$zijianBuffer || $zijianBuffer['initval'] == 0) {
                    //不扣量状态
                    $money = $ddBuffer['havemoney'];
                    $dlmoney = $ddBuffer['dailimoney'];
                } else {
                    $zijian = $zijianBuffer['zijian'] - 1;
                    if ($zijian == 0) {
                        if ($ddBuffer['totalmoney'] > $peizhi['klinitmoney'] && $ddBuffer['totalmoney'] > 0) {
                            SM('Zijian')->updateData(array(
                                'zijian' => $zijianBuffer['initval']), 'userid=' . $ddBuffer['userid']);
                            $status = 2;
                        } else {
                            $money = $ddBuffer['havemoney'];
                            $dlmoney = $ddBuffer['dailimoney'];
                        }
                    } else {
                        SM('Zijian')->updateData(array(
                            'zijian' => $zijian), 'userid=' . $ddBuffer['userid']);
                        $money = $ddBuffer['havemoney'];
                        $dlmoney = $ddBuffer['dailimoney'];
                    }
                }
            }

            //改变订单状态
            $ddBuffer['paytime'] = time();
            $ddBuffer['status'] = $status;
            $ddBuffer['preordernum'] = $data['qudao'];

            $result = SM('Dingdan')->updateData(array(
                'status' => $status,
                'paytime' => time(),
                'preordernum' => $data['qudao']), 'ddid=' . $ddBuffer['ddid']);
            if ($result === false)
                $flag = false;

            if ($money > 0) {
                $result = SM('User')->conAddData('money=money+' . $money, 'userid="' . $ddBuffer['userid'] . '"', 'money');
                SM('Jiekoupeizhi')->conAddData('money=money+' . $money, 'pzid="' . $ddBuffer['pzid'] . '"', 'money');
                if ($result === false) {
                    $flag = false;
                } else {
                    //添加资金变动
                    $newdata = array(
                        'userid' => $ddBuffer['userid'],
                        'leavemoney' => $userBuffer['money'] + $money,
                        'changemoney' => $money,
                        'desc' => '资金流水记录：订单金额' . $ddBuffer['totalmoney'] . '元，到账金额' . $money . '元',
                        'style' => 1,
                        'ddh' => $ddBuffer['ordernum'],
                        'myddh' => $ddBuffer['userid'] . date('YmdHis'),
                    );
                    $result = SL('Pay')->moneylogadd($newdata);
                    if ($result === false)
                        $flag = false;
                }
            }
            if ($dlmoney > 0 && $agentBuffer) {
                $result = SM('User')->conAddData('money=money+' . $dlmoney, 'userid=' . $agentBuffer['userid'], 'money');
                if ($result === false) {
                    $flag = false;
                } else {
                    //添加资金变动
                    $newdata = array(
                        'userid' => $agentBuffer['userid'],
                        'leavemoney' => $agentBuffer['money'] + $dlmoney,
                        'changemoney' => $dlmoney,
                        'desc' => '代理金流水记录：订单金额' . $ddBuffer['totalmoney'] . '元，到账金额' . $dlmoney . '元',
                        'style' => 3,
                        'ddh' => $ddBuffer['ordernum'],
                        'myddh' => $ddBuffer['ordernum'] . '_' . $agentBuffer['userid'],
                    );
                    $result = SL('Pay')->moneylogadd($newdata);
                    if ($result === false)
                        $flag = false;
                }
            }
            //处理事务
            if ($flag === false) {
                $dingdan->dbRollback();
                return [
                    0,
                    'db change error'];
            } else {
                $dingdan->dbCommit();
				SL('AutoTransfer')->record(array(
                        'style'=>'alipay',
                        'pzid'=>$ddBuffer['pzid'],
                        'amount'=>$data['fee'],
                        'out_biz_no'=>$ddBuffer['ordernum'],
                        'receipt_account'=>$ddBuffer['receipt_account'],
                        'is_allow_transfer'=>1
                 ));
            }
        } else {
            $status = $ddBuffer['status'];
        }

        if ($status == 2) {
            return [
                1,
                'success'];
        }

        //通知商户
        return $this->rebackUser($ddBuffer, $status, $data['method'], $data['back']);
    }

    /**
     * *通知商户
     * @params array $ddBuffer 订单数据集
     * @params int $status订单状态
     * @params string $method 提交方式 post get
     * @params int $back 返回方式 1返回url
     * @return array
     */
    public function rebackUser($ddBuffer, $status, $method = 'post', $back = 0) {
        if ($ddBuffer['tz'] == 2 && $back != 1)
            return [
                1,
                'success'];

        //通知商户
        $userBuffer = SM('User')->findData('*', 'userid="' . $ddBuffer['userid'] . '"');
        $fj = unserialize($ddBuffer['fj']);
        $ddhYuan = substr($ddBuffer['ordernum'], strlen($ddBuffer['userid']));
        $pp = $status . $ddBuffer['userid'] . $ddhYuan . $ddBuffer['totalmoney'] . $userBuffer['miyao'];
        $k = md5($pp);
        $post_data = array(
            'fxid' => $ddBuffer['userid'],
            'fxddh' => $ddhYuan,
            'fxorder' => $ddBuffer['preordernum'],
            'fxdesc' => $fj['fxdesc'],
            'fxfee' => $ddBuffer['totalmoney'],
            'fxattch' => $fj['fxattch'],
            'fxstatus' => $status,
            'fxtime' => $ddBuffer['paytime'],
            'fxsign' => $k
        );

        if ($method == 'post') {
            $json = '';
            if ($fj['fxnotifystyle'] == 2)
                $json = 'json';
            $url = $fj['fxnotifyurl'];
            $result = CURL($url, $post_data, $json);
        } else {
            $url = $fj['fxbackurl'];
            $arr = array();
            foreach ($post_data as $i => $k) {
                $arr[] = $i . '=' . urlencode($k);
            }
            $url = $url . '?' . implode('&', $arr);
            if ($back == 1)
                return [
                    1,
                    $url];

            $result = CURL($url);
        }

        if (strtolower($result) == 'success' && $ddBuffer['tz'] < 2) {
            //通知成功
            SM('Dingdan')->updateData(array(
                'tz' => 2), 'ddid="' . $ddBuffer['ddid'] . '"');
        } elseif ($ddBuffer['tz'] < 1) {
            SM('Dingdan')->updateData(array(
                'tz' => 1), 'ddid="' . $ddBuffer['ddid'] . '"');
        }

        $status = 0;
        if (strtolower($result) == 'success') {
            $status = 1;
        } else {
            $num = cookie('ddid' . $ddBuffer['ddid']);
            if (empty($num))
                $num = 0;
            if ($num < 4) {
                cookie('ddid' . $ddBuffer['ddid'], $num + 1);
                return [
                    0,
                    'notify error ' . $result];
            } else {
                $status = 0;
            }
        }

        return [
            $status,
            $result];
    }

    /**
     * 同步回调通用
     */
    public function backurl($request) {
        $ddh = $_REQUEST['ddh'];
        //根据订单号查找对应支付账户
        $ddBuffer = SM('Dingdan')->findData('*', 'ordermd5="' . $ddh . '"');
        if (!$ddBuffer) {
            return [
                0,
                '订单号不存在，请重试。'];
        }
        $fj = unserialize($ddBuffer['fj']);

        if ($ddBuffer['status'] == 2) {
            $ddBuffer['status'] = 0;
            $ddBuffer['paytime'] = 0;
            $ddBuffer['preordernum'] = '';
        }
        //通知商户
        $result = $this->rebackUser($ddBuffer, $ddBuffer['status'], 'get', 1);
        if ($result[0] === 1) {
            header('location:' . $result[1]);
            exit();
        } else {
            return $result;
        }
        exit();
    }

    /**
     * 订单状态改变，在支付成功后撤销订单
     * @param array $ddh 订单号
     */
    public function changeDingdanReback($ddh) {
        $dingdan = SM('Dingdan');
        $buffer = $dingdan->findData('*', 'ordernum="' . $ddh . '"');

        if ($buffer['status'] == 1) {
            $flag = true;
            //判断商户金额是否足够  改变商户金额
            $userBuffer = SM('User')->findData('*', 'userid="' . $buffer['userid'] . '"');
            if ($userBuffer['money'] < $buffer['havemoney']) {
                return [
                    0,
                    '商户余额不足，无法撤单。'];
            }

            //判断代理
            if ($userBuffer['agent'] && $buffer['dailimoney'] > 0) {
                $agentBuffer = SM('User')->findData('*', 'userid="' . $userBuffer['agent'] . '"');
                if ($agentBuffer && $agentBuffer['money'] < $buffer['dailimoney']) {
                    return [0,
                        '代理用户余额不足，无法撤单。'];
                }
            }

            $dingdan->dbStartTrans(); //开始事务
            $result = SM('User')->conAddData('money=money-' . $buffer['havemoney'], 'userid="' . $buffer['userid'] . '"', 'money');
            if ($result === false)
                $flag = false;
            //添加资金变动
            $newdata = array(
                'userid' => $buffer['userid'],
                'leavemoney' => $userBuffer['money'] - $buffer['havemoney'],
                'changemoney' => -$buffer['havemoney'],
                'desc' => '订单撤销资金撤回：撤销金额' . $buffer['havemoney'] . '元',
                'style' => 1,
                'ddh' => $ddh,
                'myddh' => $buffer['userid'] . date('YmdHis'),
            );
            $result = SL('Pay')->moneylogadd($newdata);
            if ($result === false)
                $flag = false;

            //判断代理
            if ($userBuffer['agent'] && $buffer['dailimoney'] > 0) {
                $result = SM('User')->conAddData('money=money-' . $buffer['dailimoney'], 'userid=' . $agentBuffer['userid'], 'money');
                if ($result === false)
                    $flag = false;
                //添加资金变动
                $newdata = array(
                    'userid' => $agentBuffer['userid'],
                    'leavemoney' => $agentBuffer['money'] - $buffer['dailimoney'],
                    'changemoney' => -$buffer['dailimoney'],
                    'desc' => '订单撤销资金撤回：撤销金额' . $buffer['dailimoney'] . '元',
                    'style' => 3,
                    'ddh' => $ddh,
                    'myddh' => $agentBuffer['userid'] . date('YmdHis'),
                );
                $result = SL('Pay')->moneylogadd($newdata);
                if ($result === false)
                    $flag = false;
            }

            //改变订单状态
            $result = SM('Dingdan')->updateData([
                'status' => 0,
                'tz' => 0,
                'preordernum' => '',
                'paytime' => 0], [
                'ordernum' => $ddh]);
            if ($result === false)
                $flag = false;

            //处理事务
            if ($flag === false) {
                $dingdan->dbRollback();
                return [
                    0,
                    '数据回滚失败，请重试。'];
            } else {
                $dingdan->dbCommit();
            }
        }

        //判断订单是否扣量
        if ($buffer['status'] == 2) {
            //改变订单状态
            SM('Dingdan')->updateData([
                'status' => 0,
                'tz' => 0,
                'preordernum' => '',
                'paytime' => 0], [
                'ordernum' => $ddh]);
        }
        return [
            1,
            '撤销成功。'];
    }

    //对需要转换域名的地址进行额外跳转
    public function changeUrl($url, $apihttp) {
        //如果当前域名与要求域名一致  则返回跳转地址
        $http = str_replace('http://', '', $apihttp);
        $https = str_replace('https://', '', $apihttp);
        if ($_SERVER['HTTP_HOST'] == $http || $_SERVER['HTTP_HOST'] == $https) {
            return $url;
        } else {
            return $apihttp . '/Pay/go?u=' . urlencode($url);
        }
    }

    /**
     * 根据订单号获取商户key
     * @param array $data ['ddh'=>订单号,'fee'=>金额,'qudao'=>渠道,'method'=>'post or get','back'=>【1代表返回路径】]
     */
    public function getKeyByDdh($fxddh) {
        //根据订单号查找对应支付账户
        $ddBuffer = SM('Dingdan')->findData('*', 'ordernum="' . $fxddh . '"');
        return $this->getKeyByDD($ddBuffer);
    }

    /**
     * 根据md5订单号获取商户key
     * @param array $data ['ddh'=>订单号,'fee'=>金额,'qudao'=>渠道,'method'=>'post or get','back'=>【1代表返回路径】]
     */
    public function getKeyByDdhMd5($ddhmd5) {
        //根据订单号查找对应支付账户
        $ddBuffer = SM('Dingdan')->findData('*', 'ordermd5="' . $ddhmd5 . '"');
        return $this->getKeyByDD($ddBuffer);
    }

    /**
     * 根据订单信息获取商户key
     * @param array $data ['ddh'=>订单号,'fee'=>金额,'qudao'=>渠道,'method'=>'post or get','back'=>【1代表返回路径】]
     */
    private function getKeyByDD($ddBuffer) {
        if (!$ddBuffer) {
            return [
                0,
                '订单号不存在，请重试。'];
        }
        //获取支付账号
        if ($ddBuffer['pzid']) {
            $pzBuffer = SM('Jiekoupeizhi')->findData('params', 'pzid="' . $ddBuffer['pzid'] . '"');
        } else {
            $pzBuffer = SL('Api')->getJkByZj($ddBuffer['zjid']);
        }
        if (!$pzBuffer) {
            return [
                0,
                '账户配置信息不存在，请确认。'];
        }
        $jkpz = unserialize($pzBuffer['params']);
        return [
            1,
            $jkpz,
            $ddBuffer['ordernum']];
    }

  
    /**
     * 描述：处理字符串
     * @return array
     * @author fengxing
     */
    public function changesecret($text, $myhttp, $qstr) {
        $mdstr = C('FX_QRCODE_KEY');
        $len = strlen($mdstr);
        if ($len > 8) {
            $mdstr = substr($mdstr, 0, 8);
        } else {
            for ($i = $len; $i < 8; $i++) {
                $mdstr .= '0';
            }
        }

        $strArr = str_split(base64_encode($text));
        $strCount = count($strArr);
        foreach (str_split($mdstr) as $key => $value)
            $key < $strCount && $strArr[$key] .= $value;
        $b = str_replace(array(
            '=',
            '+',
            '/'), array(
            'O0O0O',
            'o000o',
            'oo00o'), join($strArr));

        $url = $myhttp . '/Pay/single/md/' . $b . $qstr; //exit($url);
        return $url;
    }

    /**
     * 描述：处理字符串
     * @return array
     * @author fengxing
     */
    public function unchangesecret($md) {
        $mdstr = C('FX_QRCODE_KEY');
        $len = strlen($mdstr);
        if ($len > 8) {
            $mdstr = substr($mdstr, 0, 8);
        } else {
            for ($i = $len; $i < 8; $i++) {
                $mdstr .= '0';
            }
        }

        $strArr = str_split(str_replace(array(
            'O0O0O',
            'o000o',
            'oo00o'), array(
            '=',
            '+',
            '/'), $md), 2);
        $strCount = count($strArr);
        foreach (str_split($mdstr) as $key => $value)
            $key <= $strCount && $strArr[$key][1] === $value && $strArr[$key] = $strArr[$key][0];
        $result = base64_decode(join($strArr));

        $arr = explode('#', $result);
        return $arr;
    }
}
