<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

/**
 * 轻支付接口
 */

namespace Common\Api;

class QzfApi extends BaseApi {

    public $wg = 'http://qzf.yuanma360.com/Pay';
    public $paybank = array(
        //'ICBC' => '工商银行',
            );

    /**
     * 支付
     */
    public function pay($request) {
        $typen = $request['fxpay'];
        switch ($typen) {
            case 'bank':
                $type = 'bank';
                break;
            default:
                $type = $typen;
                break;
        }

        $data = array(
            "fxid" => $request['peizhi']['qzf_id'], //商户号
            "fxddh" => $request['fxmd5'], //商户订单号
            "fxdesc" => $request['fxdesc'], //商品名
            "fxfee" => $request['fxfee'], //支付金额 单位元
            "fxattch" => $request['fxdesc'], //附加信息
            "fxnotifyurl" => $request['fxnotifyurl'], //异步回调 , 支付结果以异步为准
            "fxbackurl" => $request['fxbackurl'], //同步回调 不作为最终支付结果为准，请以异步回调为准
            "fxpay" => $type, //支付类型 此处可选项以网站对接文档为准 微信公众号：wxgzh   微信H5网页：wxwap  微信扫码：wxsm   支付宝H5网页：zfbwap  支付宝扫码：zfbsm 等参考API
            "fxip" => $request['fxip'], //支付端ip地址
            'fxbankcode' => $request['fxbankcode'],
            'fxfs' => $request['fxfs']
        );
        $data["fxsign"] = md5($data["fxid"] . $data["fxddh"] . $data["fxfee"] . $data["fxnotifyurl"] . $request['peizhi']['qzf_key']); //加密
        $backr = CURL($this->wg, $data);
        $r = json_decode($backr, true); //json转数组
        if (empty($r))
            return [0,
                '获取支付链接失败,' . $backr]; //如果转换错误，原样输出返回

        if ($r["status"] == 1) { //验证返回信息
            return [1,
                $r["payurl"]]; //转入支付页面
        } else {
            return [0,
                '获取支付链接失败,' . $r['error']]; //输出错误信息
        }
    }

    /**
     * 异步回调
     */
    public function notify($request) {
        $fxid = $_REQUEST['fxid']; //商户编号
        $fxddh = $_REQUEST['fxddh']; //商户订单号
        $fxorder = $_REQUEST['fxorder']; //平台订单号
        $fxdesc = $_REQUEST['fxdesc']; //商品名称
        $fxfee = $_REQUEST['fxfee']; //交易金额
        $fxattch = $_REQUEST['fxattch']; //附加信息
        $fxstatus = $_REQUEST['fxstatus']; //订单状态
        $fxtime = $_REQUEST['fxtime']; //支付时间
        $fxsign = $_REQUEST['fxsign']; //md5验证签名串

        //根据订单号查找对应支付账户
        $jkpz = $this->getKeyByDdhMd5($fxddh);
        if ($jkpz[0]!=1) {
            return [
                0,
                $jkpz[1]];
        }
        $jkpz=$jkpz[1];
        $shkey = $jkpz['qzf_key'];

        $mysign = md5($fxstatus . $fxid . $fxddh . $fxfee . $shkey); //验证签名

        $fxddh = $fxddh; //商户订单号
        $fxfee = $fxfee; //支付金额
        $fxorder = $fxorder; //平台订单号
        $fxreturn = 'success'; //返回数据

        if (strtoupper($fxsign) === strtoupper($mysign)) {
            if ($fxstatus == '1') {//支付成功
                //支付成功 更改支付状态 完善支付逻辑
                $newdata = array();
                $newdata['ddh'] = $fxddh;
                $newdata['qudao'] = $fxorder;
                $newdata['fee'] = $fxfee;
                $newdata['method'] = 'post';
                $return = $this->changeDingdan($newdata);
                if ($return[0] === 1)
                    $result = $fxreturn;
                else
                    $result = 'logic fail';
            } else { //支付失败
                $result = 'status fail';
            }
        } else {
            $result = 'sign error';
        }

        exit($result);
    }
}
