<?php

// +----------------------------------------------------------------------
// | you jie fu
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: liweiwei
// +----------------------------------------------------------------------

namespace Common\Api;

class YjfApi extends BaseApi {

    public $wg = 'http://47.96.21.122:5000/gateway/index/checkpoint.do';
    public $robin = 2;
    public $type  = 4;
    public $keyId = 'jonh90188@outlook.com';
    public $type_prefix = 'yjf';
	public $thoroughfare = 'service_auto';
	public $content_type = 'json';

    public function init($request)
    {
        $data = array(
            'content_type'=>$this->content_type,
            'thoroughfare'=>$this->thoroughfare,
            'account_id'=>$request['peizhi'][$this->type_prefix.'_id'],
            's_key'=>$request['peizhi'][$this->type_prefix.'_key'],
            'amount'=>floatval($request['fxfee']),
            'out_trade_no'=>$request['fxmd5'],
            'robin'=>$this->robin,
            'type'=>$this->type,
            'keyId'=>$this->keyId,
            'success_url'=>$request['fxbackurl'],
            'callback_url'=>$request['fxnotifyurl'],
            'error_url'=>$request['fxnotifyurl'],
        );
        $data['sign'] = $this->yjf_sign($data['s_key'], ['amount' => $data['amount'], 'out_trade_no' => $data['out_trade_no']]);
        return $data;
    }

    //发送支付请求
    public function pay($request)
    {
        $data = $this->init($request);
        $result = CURL($this->wg, $data);
        if(!empty($result))
        {
            $r = json_decode($result, true);
            if(!empty($r['code']) && $r['code'] == '200' && !empty($r['data']['qrcode']))
                return [1, $r['data']["qrcode"]];
        }
        return [0, !empty($r['msg']) ? $r['msg'] : 'failed to get payment link'];
    }


    //异步回调支付结果
    public function notify($request)
    {
        if( empty($request['sign'])         ||
            empty($request['out_trade_no']) ||
            empty($request['amount'])       ||
            empty($request['trade_no']))
            return [0, 'callback parameters are incorrect'];

        $jkpz = $this->getKeyByDdhMd5($request['out_trade_no']);

        if ($jkpz[0] != 1) {
            return [
                0,
                $jkpz[1]];
        }

        $app_key= $jkpz[1][$this->type_prefix.'_key'];

        if ($this->yjf_sign($app_key, ['amount'=>$request['amount'],'out_trade_no'=>$request['out_trade_no']]) != $request['sign'])
            return [0,'signature error'];

        $result = 'fail';
        if($request['status'] == 1 || $request['status'] == 'success')
        {
            $return = $this->changeDingdan([
                'ddh'   =>$request['out_trade_no'],
                'qudao' =>$request['trade_no'],
                'fee'   =>$request['amount'],
                'method'=>'post',
            ]);

            if ($return[0] === 1)
                $result = 'success';
        }
        exit($result);
    }


    //优捷付签名规则
    protected function yjf_sign($key_id, $array)
    {
        $cipher = '';
        $data = md5(sprintf("%.2f", $array['amount']) . $array['out_trade_no']);
        $key[] ="";
        $box[] ="";
        $pwd_length = strlen($key_id);
        $data_length = strlen($data);
        for ($i = 0; $i < 256; $i++)
        {
            $key[$i] = ord($key_id[$i % $pwd_length]);
            $box[$i] = $i;
        }
        for ($j = $i = 0; $i < 256; $i++)
        {
            $j = ($j + $box[$i] + $key[$i]) % 256;
            $tmp = $box[$i];
            $box[$i] = $box[$j];
            $box[$j] = $tmp;
        }
        for ($a = $j = $i = 0; $i < $data_length; $i++)
        {
            $a = ($a + 1) % 256;
            $j = ($j + $box[$a]) % 256;

            $tmp = $box[$a];
            $box[$a] = $box[$j];
            $box[$j] = $tmp;

            $k = $box[(($box[$a] + $box[$j]) % 256)];
            $cipher .= chr(ord($data[$i]) ^ $k);
        }
        return md5($cipher);
    }
}



