<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Common\Logic;

class MyipLogic extends BaseLogic {

    protected $moduleName = '访问IP';
    protected $status = array(
        1 => '白名单',
        2 => '黑名单',
        3 => '禁止',
        4 => '放行',
    );

    /**
     * 列表
     */
    public function index($request) {
        $map = array();
        $data = ' 1=1 ';
        //高级查询
        if ($request['adminname']) {
            $request['adminname'] = $request['adminname'];
            $data .= ' AND adminname = "' . $request['adminname'] . '" ';
        }
        if ($request['ip']) {
            $map['ip'] = $request['ip'];
            $data .= ' AND ip = "' . ip2long($request['ip']) . '" ';
        }
        if ($request['title']) {
            $map['title'] = $request['title'];
            $data .= ' AND title ="' . $request['title'] . '" ';
        }
        if (is_numeric($request['status'])) {
            $map['status'] = $request['status'];
            $data .= ' AND status = "' . $request['status'] . '" ';
        }
        $perpage = C('FX_PERPAGE'); //每页行数
        $ipModel = SM('Ip');
        $count = $ipModel->selectCount(
                $data, 'id'
        ); // 查询满足要求的总记录数
        // 进行分页数据查询 注意limit方法的参数要使用Page类的属性
        $page = page($count, $request['p'], $perpage) . ',' . $perpage;

        $list = $ipModel->pageData(
                '*', $data, 'id DESC', $page
        );
        foreach ($list as $i => $iList) {
            $list[$i]['addtime'] = stringChange('formatDateTime', $iList['addtime']);
            $list[$i]['ip'] = long2ip($list[$i]['ip']);
            $list[$i]['statusname'] = $this->status[$list[$i]['status']];
        }
        $pageList = $this->pageList($count, $perpage, $map);

        $params = array(
            'list' => $list,
            'status' => $this->status,
            'page' => $pageList,
            'pageName' => $this->moduleName . '管理'
        );
        return [
            1,
            $params];
    }

    /**
     * 添加
     */
    public function add($request) {
        $params = array(
            'act' => 'add',
            'status' => $this->status,
            'pageName' => '添加' . $this->moduleName
        );
        return [
            1,
            $params];
    }

    /**
     * 修改
     */
    public function edit($request) {
        if (!$request['id']) {
            return [
                0,
                '参数错误！'];
        }
        $ipModel = SM('Ip');
        $row = $ipModel->findData('*', 'id="' . $request['id'] . '"');
        $row['ip'] = long2ip($row['ip']);
        $params = array(
            'edit' => $row,
            'status' => $this->status,
            'act' => 'edit',
            'pageName' => '修改' . $this->moduleName
        );
        return [
            1,
            $params,
            'Myip/add'];
    }

    /**
     * 保存
     */
    public function save($request) {
        $ipID = $request['id']; //获取数据标识
        $act = $request['act']; //获取模板标识
        //判断数据标识
        if (empty($ipID) && $act == 'edit') {
            return [
                0,
                '数据标识不能为空！'];
        }
        if (empty($act)) {
            return [
                0,
                '模板标识不能为空！'];
        }
        $ipModel = SM('Ip');
        $data = array();
        $data['ip'] = ip2long($request['ip']);
        $data['title'] = $request['title'];
        $data['content'] = $request['content'];
        $data['adminname'] = $this->getCookieUserName();
        $data['status'] = $request['status'];

        if (empty($data['title']))
            return [
                0,
                '请输入标题！'];
        if (empty($data['ip']))
            return [
                0,
                '请输入IP地址！'];

        if ($act == 'add') {
            $data['addtime'] = time();
            //检查ip重复
            $buffer = $ipModel->selectData(
                    'ip', 'ip="' . $data['ip'] . '"');
            if ($buffer) {
                return [
                    0,
                    'ip地址重复请更换'];
            }
            if ($ipModel->insertData($data) === false) {
                return [
                    0,
                    '添加失败'];
            } else {
                //写入日志
                $this->adminLog($this->moduleName, '添加IP地址【' . $request['ip'] . '】');
                return [
                    1,
                    '添加成功！',
                    __URL__];
            }
        } elseif ($act == 'edit') {
            $data['id'] = $ipID;
            $buffer = $ipModel->selectData(
                    'id,ip', 'id="' . $data['id'] . '"');
            if (!$buffer) {
                return [
                    0,
                    '修改信息不存在'];
            }
            $buffer = $ipModel->selectData(
                    'id,ip', 'ip="' . $data['ip'] . '" and id !="' . $ipID . '"');
            if ($buffer) {
                return [
                    0,
                    'ip地址存在，请更换。'];
            }
            if ($ipModel->updateData(
                            $data, 'id="' . $data['id'] . '"') === false) {
                return [
                    0,
                    '修改失败'];
            } else {
                //写入日志
                $this->adminLog($this->moduleName, '修改IP地址ID为【' . $ipID . '】的数据');
                return [
                    1,
                    '修改成功！',
                    __URL__];
            }
        }
    }

    /**
     * 删除
     */
    public function delete($request) {
        $ipID = $request['id']; //获取数据标识
        $idArray = explode(',', $ipID);
        if (!$ipID) {
            return [
                0,
                '数据标识不能为空',
                __URL__];
        }
        if (SM('Ip')->deleteData(
                        'id in ("' . implode('","', $idArray) . '")') === false) {
            return [
                0,
                '删除失败'];
        } else {
            //写入日志
            $this->adminLog($this->moduleName, '删除IP地址ID为【' . implode(',', $idArray) . '】的数据');
            return [
                1,
                '删除成功',
                __URL__];
        }
    }

}
