<?php
namespace Common\Logic;

class NotifyLogic extends BaseLogic
{
    //提现提醒确认关闭通知
    public function settlement_remind($request)
    {
        if(empty($request['no']))
            return [0, 'parameter error'];
        $res = $this->withdraw_notify_update($request['no']);

        if($res)
            return [1, 'success'];
        return [0, 'fail'];
    }

    //更新日志 $push_status:更新推送结果
    public function withdraw_notify_update($withdraw_no = '', $push_status = 0)
    {
        if(empty($withdraw_no))
            return false;
        if($push_status == 0){
            $data['complete_time'] = time();
        }else{
            $data['push_status'] = $push_status;
        }
        return SM('Withdraw_notify_log')->updateData($data, "withdraw_no='".$withdraw_no."'");
    }

    //提现提醒
    public function withdraw_notify_log($withdraw_no = '', $userid = 0)
    {
        if(empty($withdraw_no))
            return false;

        if($this->withdraw_notify_add($withdraw_no, $userid)){
            $ret = $this->socket_notify($withdraw_no);
            $ret = json_decode($ret, true);
            if(isset($ret['code']))
                $this->withdraw_notify_update($withdraw_no, $ret['code']);
        }
        return true;
    }

    //提现提醒日志
    public function withdraw_notify_add($withdraw_no = '', $user_id = 0)
    {
        if(empty($withdraw_no))
            return false;

        $data['notify_time'] = time();
        $data['ip'] = get_client_ip(0, true);
        $data['user_id'] = $user_id;
        $data['withdraw_no'] = $withdraw_no;

        return SM('Withdraw_notify_log')->insertData($data);
    }


    //推送消息给客户端
    public function socket_notify($withdraw_no)
    {
        $push_api_url = "http://47.244.142.14:2124";
        $post_data = array(
            "type" => "notify",
            "message" => $withdraw_no,
            "to" => 456,
        );

        $ch = curl_init ();
        curl_setopt ( $ch, CURLOPT_URL, $push_api_url );
        curl_setopt ( $ch, CURLOPT_POST, 1 );
        curl_setopt ( $ch, CURLOPT_HEADER, 0 );
        curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt ( $ch, CURLOPT_POSTFIELDS, $post_data );
        curl_setopt ($ch, CURLOPT_HTTPHEADER, array("Expect:"));
        $return = curl_exec ( $ch );
        curl_close ( $ch );
        return $return;
    }

}