<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Common\Logic;

class ParamLogic extends BaseLogic {

    protected $moduleName = '参数';
    public $template = array(
        'auto' => '官方默认',
        'kuaiyun' => '黑色',
        'wiipay' => '白色简约',
        //'ipaynow'=>'纯色朴素',
        'ispay' => '简洁大气'
    );

    /**
     * 列表
     */
    public function index($request) {
        $pezhi = SM('Peizhi');
        $edit = $pezhi->findData(
                '*', 'id=1'
        );
        $file = SS('params');
        if (!empty($file))
            $edit = array_merge($edit, $file);

        $edit = stringChange('formatMoneyByArray', $edit, array(
            'klinitmoney',
            'minpay',
            'baozhengjin',
            'paytest',
            'dffl'));

        $edit['smskey'] = '*******';

        $params = array(
            'edit' => $edit,
            'template' => $this->template,
            'pageName' => $this->moduleName . '管理'
        );
        return [
            1,
            $params];
    }

    /**
     * 保存
     */
    public function save($request) {
        $data = array();
        $data['sitename'] = $request['sitename'];
        $data['closeweb'] = $request['closeweb'];
        $data['ifregcheck'] = $request['ifregcheck'];
        $data['ifagent'] = $request['ifagent'];
        $data['ifcheckka'] = $request['ifcheckka'];
        $data['baozhengjin'] = $request['baozhengjin'];
        $data['bzjuserid'] = $request['bzjuserid'];
        $data['apihttp'] = $request['apihttp'];
        $data['apijump'] = $request['apijump'];
        $data['changeapitime'] = $request['changeapitime'];
        $data['ifkl'] = $request['ifkl'];
        $data['klvalue'] = $request['klvalue'];
        $data['klzijian'] = $request['klzijian'];
        $data['klinitmoney'] = $request['klinitmoney'];
        $data['minpay'] = $request['minpay'];
        $data['xieyi'] = $request['xieyi'];
        $data['notice'] = $request['notice'];
        //$data['ifopenapi'] = $request['ifopenapi'];
        $data['phone'] = $request['phone'];
        $data['qq'] = $request['qq'];
        $data['beian'] = $request['beian'];
        $data['balancestyle'] = $request['balancestyle'];
        $data['balancetime'] = $request['balancetime'];
        $data['paytest'] = $request['paytest'];
        $data['ddhlength'] = $request['ddhlength'];
        $data['iffl'] = $request['iffl'];
        $data['dffl'] = $request['dffl'];
        $data['httpstyle'] = $request['httpstyle'];
        $data['logopath'] = $request['logopath'];
        $data['ifdlmoney'] = $request['ifdlmoney'];


        if (empty($data['sitename'])) {
            return [
                0,
                '请填写网站名称'];
        }
        if (!empty($data['bzjuserid'])) {
            $buffer = SM('User')->findData('username', 'userid="' . $data['bzjuserid'] . '"');
            if (!$buffer)
                return [
                    0,
                    '保证金收款商户id不存在。请更换。'];
        }
        if (!empty($data['apijump']) && substr($data['apijump'], 0, 4) != 'http') {
            return [
                0,
                '请填写正确的api跳转域名'];
        }

        $peizhi = $this->getPZ();

        //记录数据到文件
        $file = array();
        $file['ifshowerror'] = $request['ifshowerror'];
        $file['ifsms'] = $request['ifsms'];
        $file['smsstyle'] = $request['smsstyle'];
        $file['smstimes'] = $request['smstimes'];
        $file['smsaccount'] = $request['smsaccount'];

        if ($request['smskey'] == '*******' || empty($request['smskey'])) {
            $file['smskey'] = $peizhi['smskey'];
        } else {
            $file['smskey'] = $request['smskey'];
        }
        $file['smssign'] = $request['smssign'];
        $file['smstemplate'] = $request['smstemplate'];
        $file['ifopenusercheck'] = $request['ifopenusercheck'];
        $file['ifopenusercheckstyle'] = $request['ifopenusercheckstyle'];
        $file['ifopenusercheckauto'] = $request['ifopenusercheckauto'];
        $file['template'] = $request['template'];
        //判断界面是否存在
        if ($file['template'] != 'auto') {
            if (!file_exists(APP_PATH . "Index/View/Index" . $file['template'])) {
                return [
                    0,
                    '没有该模板文件，请查看演示或前往官方购买,官方地址【http://www.qianlicc.cc】'];
            }
        }

        $file['templatecookie'] = $request['templatecookie'];
        $file['hiddenclosejiekou'] = $request['hiddenclosejiekou'];
        $file['ewmcreate'] = $request['ewmcreate'];
        $file['ifagentopenuser'] = $request['ifagentopenuser'];
        $file['ifagentopenusercheck'] = $request['ifagentopenusercheck'];
        $file['accessip'] = $request['accessip'];
        $file['closereg'] = $request['closereg'];
        $file['ifregagent'] = $request['ifregagent'];
        $file['ifregcheckagent'] = $request['ifregcheckagent'];

        SS('params', $file);

        $pezhi = SM('Peizhi');
        if ($pezhi->updateData(
                        $data, 'id=1') === false) {
            return [
                0,
                '修改失败'];
        } else {
            //写入日志
            $this->adminLog($this->moduleName, '修改配置参数数据');
            return [
                1,
                '修改成功！',
                __URL__];
        }
    }

    /**
     * 获取配置信息
     */
    public function getPZ() {
        $file = SS('params');
        if (empty($file))
            $file = array();
        $data = SM('Peizhi')->findData('*', 'id=1');
        $result = array_merge($file, $data);
        return $result;
    }

}
