<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Common\Logic;

class PayLogic extends BaseLogic {

    protected $moduleName = '账单';
    public $zt = array(
        0 => '<font color="red">未支付</font>',
        1 => '<font color="green">已支付</font>',
        2 => '<font color="orange">冻结</font>',
        3 => '<font color="orange">取消</font>');
    public $paylogzt = array(
        1 => '充值',
        2 => '提现',
        3 => '代理佣金');
    public $daifuzt = array(
        0 => '<font color="red">未提交</font>',
        1 => '<font color="orange">已提交</font>',
        2 => '<font color="red">失败</font>',
        3 => '<font color="green">成功</font>');
    public $fanhuizt = array(
        0 => '发起支付',
        1 => '<font color="green">支付成功</font>',
        2 => '<font color="red">支付失败</font>');

    /**
     * 列表
     */
    public function index($request) {
        $map = array();
        $data = ' 1=1 ';
        //高级查询
        if ($request['ddh']) {
            $map['ddh'] = $request['ddh'];
            $data .= ' AND ddh = "' . $request['ddh'] . '" ';
        }
        if ($request['userid']) {
            $map['userid'] = $request['userid'];
            $data .= ' AND userid = "' . $request['userid'] . '" ';
        }
        if (!is_numeric($request['status'])) {
            $request['status'] = 0;
            $_REQUEST['status'] = 0;
        }
        $map['status'] = $request['status'];
        $data .= ' AND status ="' . $request['status'] . '" ';

        $start = $request['start'];
        if (strstr($start, '-')) {
            $start = strtotime($start);
        }
        $end = $request['end'];
        if (strstr($end, '-')) {
            $end = strtotime($end);
        }
        if ($start) {
            if (empty($end))
                $end = time();
            $map['start'] = $start;
            $map['end'] = $end;
            $request['start'] = date('Y-m-d', $start);
            $request['end'] = date('Y-m-d', $end);
            $data .= ' AND addtime between "' . ($start) . '" and "' . ($end) . '" ';
        }

        $pay = SM('Pay');
        $count = $pay->selectCount(
                $data, 'id'); // 查询满足要求的总记录
        // 进行分页数据查询 注意limit方法的参数要使用Page类的属性
        $perpage = C('FX_PERPAGE'); //每页行数
        $page = page($count, $request['p'], $perpage) . ',' . $perpage;
        $list = $pay->pageData('*', $data, 'id DESC', $page);
        foreach ($list as $i => $iList) {
            $list[$i]['statusname'] = $this->zt[$iList['status']];
            $list[$i]['addtime'] = stringChange('formatDateTime', $iList['addtime']);
            $list[$i] = stringChange('formatMoneyByArray', $list[$i], array(
                'money',
                'dffl'));
        }
        $pageList = $this->pageList($count, $perpage, $map);

        $titlename = $this->zt[$request['status']];

        //统计数据
        $times = strtotime(date('Y-m-d', time()));
        $tj = array();
        $tj['today'] = $pay->sumData('money', 'status=0 and addtime>=' . $times);
        $tj['paytoday'] = $pay->sumData('money', 'status=1 and addtime>=' . $times);
        $tj['all'] = $pay->sumData('money', $data);
        $tj['payall'] = $pay->sumData('money', $data . ' and status=1');
        foreach ($tj as $i => $iTj) {
            if (empty($iTj))
                $tj[$i] = 0;
        }
        $tj = stringChange('formatMoneyByArray', $tj, array(
            'today',
            'paytoday',
            'all',
            'payall'));

        $params = array(
            'zt' => $this->zt,
            'tj' => $tj,
            'list' => $list,
            'page' => $pageList,
            'pageName' => $titlename . $this->moduleName . '管理'
        );
        return [
            1,
            $params];
    }

    /**
     * 保存
     */
    public function save($request) {
        $id = $request['id']; //获取数据标识
        $status = $request['status']; //获取数据标识

        if (empty($id) || !is_numeric($status)) {
            return [
                0,
                '数据标识不能为空！'];
        }

        if (!is_array($id)) {
            $id = explode(',', $id);
        }

        //当数据状态为3的时候不能再修改状态
        $buffer = SM('Pay')->selectData('*', 'id in ("' . implode('","', $id) . '")');
        foreach ($buffer as $iBuffer) {
            if ($iBuffer['status'] == 3) {
                return [
                    0,
                    '已取消的数据不能更改状态！'];
            }
        }
        //状态为3的时候返还用户金额

        $pay = SM('Pay');
        $pay->dbStartTrans(); //开始事务

        $flag = true;
        $flag = $pay->updateData(array(
            'status' => $status), 'id in ("' . implode('","', $id) . '")');

        //为用户增加金额
        $buffer = SM('Pay')->findData('*', 'id="' . $id[0] . '"');
        if ($status == 3 && $buffer['money'] > 0) {
            $userBuffer = SM('User')->findData('*', 'userid="' . $buffer['userid'] . '"');
            $changemoney = ($buffer['money'] + $buffer['dffl']);
            $result = SM('User')->conAddData('money=money+' . $changemoney, 'userid="' . $buffer['userid'] . '"', 'money');
            if ($result === false)
                $flag = false;
            $result = SM('User')->conAddData('tx=tx-' . $buffer['money'], 'userid="' . $buffer['userid'] . '"', 'tx');
            if ($result === false)
                $flag = false;

            //添加资金变动
            $data = array(
                'userid' => $buffer['userid'],
                'leavemoney' => $userBuffer['money'] + $changemoney,
                'changemoney' => $changemoney,
                'desc' => '提现取消返还金额：' . $changemoney . '元',
                'style' => 2,
                'ddh' => $buffer['ddh'],
                'myddh' => $buffer['userid'] . date('YmdHis'),
            );
            $result = $this->moneylogadd($data);
            if ($result === false)
                $flag = false;
        }

        //处理事务
        if ($flag === false) {
            $pay->dbRollback();
            return [
                0,
                '修改失败！'];
        } else {
            $pay->dbCommit();
            $this->adminLog($this->moduleName, '修改账单状态id为【' . implode(',', $id) . '】的数据');
            return [
                1,
                '修改成功！'];
        }
    }

    /**
     * 已支付账单
     */
    public function yzf($request) {
        header('Location:' . U('Pay/index', array(
                    'status' => 1)));
        exit();
    }

    /**
     * 发起支付
     * $check pzid支付id
     */
    public function payApi($request, $check = '') {
        //过滤request
        $request = array(
            'fxid' => $request['fxid'],
            'fxddh' => $request['fxddh'],
            'fxdesc' => $request['fxdesc'],
            'fxfee' => $request['fxfee'],
            'fxattch' => $request['fxattch'],
            'fxnotifyurl' => $request['fxnotifyurl'],
            'fxbackurl' => $request['fxbackurl'],
            'fxpay' => $request['fxpay'],
            'fxsign' => $request['fxsign'],
            'fxip' => $request['fxip'],
            'fxsmstyle' => $request['fxsmstyle'],
            'fxbankcode' => $request['fxbankcode'],
            'fxfs' => $request['fxfs'],
            'fxuserid' => $request['fxuserid'],
            'fxddstyle' => $request['fxddstyle'],
            'fxnotifystyle' => $request['fxnotifystyle'],
            'jumpflag' => $request['jumpflag'],
        );

        $fxid = $request['fxid'];
        $fxddh = $request['fxddh'];
        $fxdesc = $request['fxdesc'];
        $fxfee = $request['fxfee'];
        $fxattch = $request['fxattch'];
        $fxnotifyurl = $request['fxnotifyurl'];
        $fxbackurl = $request['fxbackurl'];
        $fxpay = $request['fxpay'];
        $fxsign = $request['fxsign'];
        $fxip = $request['fxip'];
        $fxsmstyle = $request['fxsmstyle'];
        $fxbankcode = $request['fxbankcode'];
        $fxfs = $request['fxfs'];
        $fxuserid = $request['fxuserid'];
        $fxddstyle = $request['fxddstyle']; //0普通订单 1充值订单 2保证金 3测试体验订单 4商户二维码
        $fxnotifystyle = $request['fxnotifystyle']; //异步数据类型 默认1表单数据 2json
        $jumpflag = $request['jumpflag'];
        if (empty($fxddstyle) || !is_numeric($fxddstyle))
            $fxddstyle = 0;

        if (empty($fxid)) {
            return [
                0,
                '参数格式有误。请尝试用html表单提交。'];
        }

        //判断商户号 key是否存在
        $userBuffer = SM('User')->findData('*', 'userid="' . $fxid . '"');
        if (!$userBuffer || $userBuffer['status'] == 1) {
            return [
                0,
                '商户号错误。'];
        }
        $fxkey = $userBuffer['miyao'];

        //判断订单长度
        if (strlen($fxddh) > 40) {
            return [
                0,
                '订单号长度必须小于40位。'];
        }

        if (empty($fxfee) || !is_numeric($fxfee * 100) || $fxfee <= 0) {
            return [
                0,
                '支付金额有误。'];
        }

        //判断回调地址是否是http
        if (!checkString('checkIfHttp', $fxnotifyurl) || !checkString('checkIfHttp', $fxbackurl)) {
            return [
                0,
                '同步、异步回调网址有误。'];
        }

        $ddhfull = $fxid . $fxddh;
        $ddhmd5 = substr(md5($ddhfull), 8, 16);

        //判断签名是否正确 商务号+商户订单号+支付金额+异步通知地址+商户秘钥
        if ($fxsign != md5($fxid . $fxddh . $fxfee . $fxnotifyurl . $fxkey)) {
            return [
                0,
                '签名错误。'];
        }

        //判断订单号重复
        $ddBuffer = SM('Dingdan')->findData('*', 'ordernum="' . $ddhfull . '"');
        if ($ddBuffer['status'] > 0) {
            return [
                0,
                '订单已支付。'];
        }
//        if ($ddBuffer) {
//            return [0,
//                '订单号重复，请更换后重试。'];
//        }

        if (strstr($fxbackurl, '?') !== false) {
            return [
                0,
                '同步地址不能带问号，请确认。'];
        }

        //判断自动切换账户
        global $publicData;
        $peizhi = $publicData['peizhi'];

        if (empty($check)) { //非检测模式
            //pay是否在允许范围内 接口及配置都有数据
            $jiekou = SM('Jiekou')->selectData('*', '1=1', 'jkid asc');

            $jiekoubuffer = stringChange('arrayKey', $jiekou, 'jkstyle');
            if (!$jiekoubuffer[$fxpay]) {
                return [
                    0,
                    '请求类型有误。'];
            }

            if ($jiekoubuffer[$fxpay]['ifopen'] != 1) {
                return [
                    0,
                    '该请求类型通道关闭。'];
            }


            $out = 1; //判断条件是否继续 默认1继续 0跳出用于zjbuffer的获取

            if ($ddBuffer) {
                $zjbuffer = SM('Jiekouzj')->findData('*', 'zjid="' . $ddBuffer['zjid'] . '"');
                $out = 0;
            }

            //银行绑定账户高于个性设定
            if ($out && strstr($fxpay, 'bank') !== false && !empty($fxbankcode)) {
                $bankBuffer = SM('Bank')->findData('*', 'bankcode="' . $fxbankcode . '"');
                if ($bankBuffer['pzid']) {
                    $zjbuffer = SM('Jiekouzj')->findData('*', 'jkid="' . $jiekoubuffer[$fxpay]['jkid'] . '" and pzid="' . $bankBuffer['pzid'] . '" and ifopen=1');
                    $out = 0;
                }
            }

            //获取用户配置指定接口信息
            $jkuser = SM('JiekouUser')->findData('*', 'userid="' . $fxid . '" and jkid="' . $jiekoubuffer[$fxpay]['jkid'] . '"');
            if ($out && $jkuser && !empty($jkuser['pzid'])) {
                $zjbuffer = SM('Jiekouzj')->findData('*', 'jkid="' . $jiekoubuffer[$fxpay]['jkid'] . '" and pzid="' . $jkuser['pzid'] . '" and ifopen=1');
                $out = 0;
            }

            //获取一个对接的支付接口用于支付，如果开启轮询则不使用自定义应用接口
            if ($out && $jiekoubuffer[$fxpay]['ifround'] != 1) {
                $zjbuffer = SM('Jiekouzj')->findData('*', 'jkid="' . $jiekoubuffer[$fxpay]['jkid'] . '" and ifopen=1 and ifchoose=1');
                $out = 0;
            }

            if ($out) {
                $list = unserialize($jiekoubuffer[$fxpay]['list']);


                $is_upper_limit = 0;
                $receipt_accounts = SM('Jiekouzj')->selectData('*', 'zjid in('.implode(',', array_keys($list)).')');
                if(!empty($receipt_accounts)){
                    foreach ($receipt_accounts as $account){
                        if($account['danbi'] >0 && $request['fxfee'] > $account['danbi'])
                            unset($list[$account['zjid']]);
                    }
                    if(empty($list))
                        $is_upper_limit = 1;
                }

                if($is_upper_limit)
                    return [ 0,'请更换收款通道，支付金额超过通道收款上限。'];

                //获取支付接口 按照权重
                $rand = array();
                foreach ($list as $i => $iList) {
                    $rand = array_merge($rand, array_fill(count($rand), $iList['power'], $i));
                }
                $zjid = $rand[rand(0, count($rand) - 1)];
                $zjbuffer = SM('Jiekouzj')->findData('*', 'zjid="' . $zjid . '"');
            }

            if (!$zjbuffer) {
                return [
                    0,
                    '该请求类型暂时不可用123。'];
            }

            if ($jiekoubuffer[$fxpay]['ifround'] != 1) {
                $changetime = $peizhi['changeapitime'];
                if ($changetime > 0) {
                    if (empty($zjbuffer['changetime'])) {
                        SM('Jiekouzj')->updateData(array(
                            'changetime' => (time() + 60 * $changetime)), 'zjid="' . $zjbuffer['zjid'] . '"');
                    } else {
                        //支付时间
                        $tmpBuffer = SM('Dingdan')->findData('*', 'status>0 and jkstyle="' . $fxpay . '"', 'addtime desc');
                        if ($zjbuffer['changetime'] < time() && $tmpBuffer['addtime'] < (time() + 60 * $changetime)) {
                            $tmpBuffer2 = SM('Jiekouzj')->selectData('*', 'jkid="' . $zjbuffer['jkid'] . '" and ifopen=1 and ifchoose!=1', 'zjid asc');
                            $newid = $zjbuffer['zjid'];
                            if ($tmpBuffer2) {
                                foreach ($tmpBuffer2 as $iBuffer2) {
                                    if ($newid != $zjbuffer['zjid'])
                                        continue;
                                    if ($iBuffer2['zjid'] > $zjbuffer['zjid']) {
                                        $newid = $iBuffer2['zjid'];
                                        $newzjbuffer = $iBuffer2;
                                    }
                                }
                                if ($newid == $zjbuffer['zjid']) {
                                    $newid = $tmpBuffer2[0]['zjid'];
                                    $newzjbuffer = $tmpBuffer2[0];
                                }
                            }
                            if ($newid != $zjbuffer['zjid']) {
                                SM('Jiekouzj')->updateData(array(
                                    'changetime' => 0,
                                    'ifchoose' => 0), 'zjid="' . $zjbuffer['zjid'] . '"');
                                SM('Jiekouzj')->updateData(array(
                                    'changetime' => (time() + 60 * $changetime),
                                    'ifchoose' => 1), 'zjid="' . $newid . '"');
                                $zjbuffer = $newzjbuffer;
                            }
                        }
                    }
                }
            }

            //判断用户接口权限 用户没有并且默认关闭 或者 用户关闭
            if (!$jkuser)
                $jkuser = SM('JiekouUser')->findData('*', 'userid="' . $fxid . '" and jkid="' . $zjbuffer['jkid'] . '"');
            if ((isset($jkuser['ifopen']) && 1 != $jkuser['ifopen']) || (!$jkuser && empty($jiekoubuffer[$fxpay]['ifuseropen'])) || empty($jiekoubuffer[$fxpay]['ifopen'])) {
                return [
                    0,
                    '没有接口权限，请申请开通后尝试。'];
            }

            if ($jkuser && !empty($jkuser['fl']))
                $fl = $jkuser['fl']; //用户自定义费率
        } else {
            $zjbuffer = SM('Jiekouzj')->findData('*', 'zjid="' . $check . '"');
        }

        //查询支付账户和类型
        $jkpz = SM('Jiekoupeizhi')->findData('*', 'pzid="' . $zjbuffer['pzid'] . '"');
	if (!$jkpz) {
            return [
                0,
                '该请求类型暂时不可用456。'];
        }

        $apihttp = $peizhi['httpstyle'] . '://' . $peizhi['apihttp'];

        //判断跳转
        if ($fxbankcode && empty($jumpflag)) {
            //传入的银行号是否正确
            if (!$bankBuffer)
                $bankBuffer = SM('Bank')->findData('*', 'bankcode="' . $fxbankcode . '"');
            if (empty($bankBuffer))
                $request['fxbankcode'] = '';
        }
        if (!empty($zjbuffer['ifjump']) && empty($jumpflag) && empty($fxbankcode)) {
            $wg = $apihttp . '/Pay';
            $request = stringChange('removeEmpty', $request);
            return [
                1,
                $apihttp . '/Pay/' . $zjbuffer['ifjump'] . '?' . http_build_query($request) . '&wg=' . urlencode($wg)];
            exit();
        }

        /**
         * 支付总接口
         * $request = array(
          'id' => $jkpz['zjid'], 接口中间表id 获取接口账户及参数
          'peizhi' => unserialize($jkpz['params']),
          'style' => $jkpz['style'], 账户类型 alipay
          'fxddh' => $fxid . $fxddh, 订单号
          'fxdesc' => $fxdesc, 说明
          'fxfee' => $fxfee, 金额
          'fxattch' => $fxattch, 原样返回
          'fxnotifyurl' => $fxnotifyurl, 异步路径
          'fxbackurl' => $fxbackurl, 同步路径
          'fxpay' => $fxpay, 支付接口类型 wxwap
          'fxip' => $fxip  IP地址
         * 'isjsapi'=>0 或1 是否调用jsapi
          );
         */
        $jkdata = array(
            'id' => $zjbuffer['zjid'],
            'peizhi' => unserialize($jkpz['params']),
            'apihttp' => $apihttp,
            'style' => $jkpz['style'],
            'fxddh' => $ddhfull,
            'fxmd5' => $ddhmd5,
            'fxdesc' => $fxdesc,
            'fxfee' => $fxfee,
            'fxattch' => $fxattch,
            'fxnotifyurl' => $apihttp . "/Pay/notify/" . $jkpz['style'], //本站回调
            'fxbackurl' => $apihttp . "/Pay/backurl/" . $jkpz['style'] . '/1/ddh/' . $ddhmd5, //本站回调 $fxbackurl, //用户同步回调 用户需要做订单查询以支持实时订单状态
            'fxpay' => $fxpay,
            'fxip' => $fxip,
            'fxbankcode' => $fxbankcode,
            'fxfs' => $fxfs,
            'fxuserid' => $fxuserid,
            'fxddstyle' => $fxddstyle
        );

        //调用接口返回
        $result = SA(ucfirst($jkpz['style']))->pay($jkdata);

        if ($result[0] == 1) {
            if (empty($fl) || $fl == '0.00')
                $fl = $zjbuffer['fl']; //没有自定义费率按照接口费率
            $havemoney = $fxfee - $fxfee * $fl / 100;
            if ($havemoney < 0.01) {
                $havemoney = 0;
            } else {
                $havemoney = round($havemoney, 2);
            }

            $fj = array(
                'fxdesc' => $fxdesc,
                'fxattch' => $fxattch,
                'fxnotifyurl' => $fxnotifyurl,
                'fxbackurl' => $fxbackurl,
                'fxip' => $fxip,
                'fxbankcode' => $fxbankcode,
                'fxfs' => $fxfs,
                'fxuserid' => $fxuserid,
                'fxnotifystyle' => $fxnotifystyle
            );

            //获取代理money
            $dailimoney = 0;
            if ($userBuffer['agent'] && $peizhi['ifdlmoney'] != 1) {
                $agentBuffer = SM('User')->findData('*', 'ifdlmoney!=1 and userid="' . $userBuffer['agent'] . '"');
                if ($agentBuffer) {
                    //接口id是否开启
                    $jkUserBuffer = SM('JiekouUser')->findData('*', 'userid="' . $userBuffer['agent'] . '" and jkid="' . $jiekoubuffer[$fxpay]['jkid'] . '"');
                    $agentfl = $zjbuffer['fl'];
                    if ($jkUserBuffer && $jkUserBuffer['ifopen'] == 1) {
                        $agentfl = $jkUserBuffer['fl'];
                    }
                    if ($agentfl < $fl) {
                        $dailimoney = $fxfee * ($fl - $agentfl) / 100;
                        if ($dailimoney < 0)
                            $dailimoney = 0;
                    }
                }
            }

            $ddstyle = $fxddstyle;
            //写入订单
            $data = array(
                'status' => 0,
                'ordernum' => $ddhfull,
                'ordermd5' => $ddhmd5,
                'userid' => $fxid,
                'totalmoney' => $fxfee,
                'havemoney' => $havemoney,
                'dailimoney' => $dailimoney,
                'ddstyle' => $ddstyle,
                'tz' => 0,
                'preordernum' => '',
                'zjid' => $zjbuffer['zjid'],
                'pzid' => $zjbuffer['pzid'],
                'addtime' => time(),
                'fl' => $fl,
                'jkstyle' => $fxpay,
                'paytime' => 0,
                'fj' => serialize($fj),
                'receipt_account'=>!empty($jkpz['uname']) ? $jkpz['uname'] : ''
            );
            if ($ddBuffer) {
                SM('Dingdan')->updateData($data, 'ddid="' . $ddBuffer['ddid'] . '"');
            } else {
                SM('Dingdan')->insertData($data);
            }
        }

        //二维码收银台
        if ($fxsmstyle == 1 && strstr($fxpay, 'sm')) {
            if ($result[0] === 1) {
                $result[1] = $apihttp . '/Pay/ewm/ddh/' . $ddhfull . '?qr=' . urlencode($result[1]) . '&md=' . md5($fxid . $fxddh . $result[1] . C('FX_QRCODE_KEY'));
            }
        }

        return $result;
    }

    /**
     * 查询订单状态
     */
    public function payQuery($request) {
        $fxid = $request['fxid'];
        $fxddh = $request['fxddh'];
        $fxsign = $request['fxsign'];
        $fxaction = $request['fxaction'];

        //判断商户号 key是否存在
        $userBuffer = SM('User')->findData('*', 'userid="' . $fxid . '"');
        if (!$userBuffer || $userBuffer['status'] == 1) {
            return [
                0,
                '商户号错误。'];
        }

        $fxkey = $userBuffer['miyao'];
        //判断订单长度
        if (strlen($fxddh) > 40) {
            return [
                0,
                '订单号长度必须小于40位。'];
        }

        //判断签名是否正确 商务号+商户订单号+商户秘钥
        if ($fxsign != md5($fxid . $fxddh . $fxaction . $fxkey)) {
            return [
                0,
                '签名错误。'];
        }

        $buffer = SM('Dingdan')->findData('*', 'ordernum="' . $fxid . $fxddh . '"');
        if (!$buffer) {
            return [
                0,
                '订单号不存在。'];
        }

        if ($buffer['status'] == 2) {
            $buffer['status'] = 0;
            $buffer['paytime'] = 0;
            $buffer['preordernum'] = '';
        }

        $fj = unserialize($buffer['fj']);
        $data = array(
            'fxid' => $fxid,
            'fxstatus' => $buffer['status'],
            'fxddh' => $fxddh,
            'fxorder' => $buffer['preordernum'],
            'fxdesc' => $fj['fxdesc'],
            'fxfee' => $buffer['totalmoney'],
            'fxattch' => $fj['fxattch'],
            'fxtime' => $buffer['paytime'],
            'fxsign' => md5($buffer['status'] . $fxid . $fxddh . $buffer['totalmoney'] . $fxkey)
        );
        //订单状态+商务号+商户订单号+支付金额+商户秘钥

        return [
            1,
            $data];
    }

    /**
     * 资金变动日志
     */
    public function moneylog($request) {
        $perpage = C('FX_PERPAGE'); //每页行数
        $map = array();
        $data = ' 1=1 ';
        //高级查询
        if ($request['userid']) {
            $map['userid'] = $request['userid'];
            $data .= ' AND userid = "' . $request['userid'] . '" ';
        }
        if (is_numeric($request['style'])) {
            $map['style'] = $request['style'];
            $data .= ' AND style ="' . $request['style'] . '" ';
        }
        $start = $request['start'];
        if (strstr($start, '-')) {
            $start = strtotime($start);
        }
        $end = $request['end'];
        if (strstr($end, '-')) {
            $end = strtotime($end);
        }
        if ($start) {
            if (empty($end))
                $end = time();
            $map['start'] = $start;
            $map['end'] = $end;
            $request['start'] = date('Y-m-d', $start);
            $request['end'] = date('Y-m-d', $end);
            $data .= ' AND addtime between "' . ($start) . '" and "' . ($end) . '" ';
        }
        $log = SM('PayLog');
        $count = $log->selectCount(
                $data, 'id'); // 查询满足要求的总记录
        // 进行分页数据查询 注意limit方法的参数要使用Page类的属性
        $page = page($count, $request['p'], $perpage) . ',' . $perpage;
        $list = $log->pageData(
                '*', $data, 'id desc', $page);
        foreach ($list as $i => $iList) {
            $list[$i]['stylename'] = $this->paylogzt[$iList['style']];
            $list[$i] = stringChange('formatMoneyByArray', $list[$i], array(
                'changemoney',
                'leavemoney'));
        }

        $pageList = $this->pageList($count, $perpage, $map);

        /* 载入模板标签 */
        $params = array(
            'list' => $list,
            'page' => $pageList,
            'style' => $this->paylogzt,
            'pageName' => '资金变动管理'
        );
        return [
            1,
            $params];
    }

    /**
     * 资金变动日志清除
     */
    public function moneylogdelete($request) {
        $logID = $request['clear']; //获取数据标识
        if (!$logID) {
            return [
                0,
                '数据标识不能为空！',
                U('Pay/moneylog')];
        }

        $log = SM('PayLog');
        if ($log->deleteData('addtime < ' . (time() - 30 * 24 * 3600)) === false) {
            return [
                0,
                '删除失败'];
        } else {
            //写入日志
            $this->adminLog($this->moduleName, '删除最近30天资金变动日志记录');
            return [
                1,
                '删除成功！',
                U('Pay/moneylog')];
        }
    }

    /**
     * 资金变动日志添加
     */
    public function moneylogadd($data) {
        $data['addtime'] = time();
        return SM('PayLog')->insertData($data);
    }

    /**
     * 判断是否有新订单
     */
    public function checkneworder($request) {
        $time = $request['times'];
        $status = $request['status'];
        $where = 'status="' . $status . '" and addtime>"' . strtotime($time) . '"';
        if (empty($time)) {
            $where = 'status="' . $status . '"';
        }
        $buffer = SM('Pay')->findData('*', $where);
        if ($buffer) {
            return [
                1,
                1];
        }
        return [
            1,
            0];
    }
    
    public function tongdao($request) {
        //dump(123);exit;
        $jkBuffer = $this->getJkArrayKeyID();
        $jkpzBuffer = $this->getPzArrayKeyID();
        //获取所有可用接口列表
        $jkzjBuffer = SM('Jiekouzj')->selectData('*', '1=1', 'zjid asc');

        foreach ($jkzjBuffer as $i => $iJkzjBuffer) {
            $jkzjBuffer[$i]['jkname'] = $jkBuffer[$iJkzjBuffer['jkid']]['jkname'];
            $jkzjBuffer[$i]['jkstyle'] = $jkBuffer[$iJkzjBuffer['jkid']]['jkstyle'];
            $jkzjBuffer[$i]['pzname'] = $jkpzBuffer[$iJkzjBuffer['pzid']]['pzname'];
            $jkzjBuffer[$i]['zongxian'] = $jkpzBuffer[$iJkzjBuffer['pzid']]['zongxian'];
            $jkzjBuffer[$i]['dayxian'] = $jkpzBuffer[$iJkzjBuffer['pzid']]['dayxian'];
            $zs=M("")->query("select count(ddid) as zs from fx_dingdan where zjid=".$iJkzjBuffer['zjid']);
            $jkzjBuffer[$i]['zshou'] = $zs[0]['zs'];
            $day=strtotime(date('Y-m-d',time()));
            $js=M("")->query("select count(ddid) as js from fx_dingdan where paytime>$day and zjid=".$iJkzjBuffer['zjid']);
            $jkzjBuffer[$i]['jshou'] = $js[0]['js'];
            $jkzjBuffer[$i]['ifopen'] = $iJkzjBuffer['ifopen'] == 1 ? '开启' : '关闭';
            $jkzjBuffer[$i]['ifopenno'] = $iJkzjBuffer['ifopen'] == 1 ? '关闭' : '开启';
            $jkzjBuffer[$i]['ifchoose'] = $iJkzjBuffer['ifchoose'] == 1 ? '应用' : '未应用';
            $jkzjBuffer[$i] = stringChange('formatMoneyByArray', $jkzjBuffer[$i], array(
                'fl'));
        }

        $params = array(
            'list' => $jkzjBuffer,
            'pageName' => '接口检测'
        );
        return [
            1,
            $params];
    }
    /**
     * 获取以jkid为键值的数组
     */
    public function getJkArrayKeyID() {
        $jiekou = SM('Jiekou');
        $jiekouBuffer = $jiekou->selectData(
                '*', '1=1', 'jkid ASC'
        );
        return stringChange('arrayKey', $jiekouBuffer, 'jkid');
    }

    /**
     * 获取以pzid为键值的数组
     */
    public function getPzArrayKeyID() {
        $jiekoupz = SM('Jiekoupeizhi');
        $jiekoupzBuffer = $jiekoupz->selectData(
                '*', '1=1', 'pzid ASC'
        );
        return stringChange('arrayKey', $jiekoupzBuffer, 'pzid');
    }
}
