<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2017 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Common\Logic;

class ShorturlLogic extends BaseLogic {

    protected $moduleName = '短连接';

    /**
     * 列表
     */
    public function index($request) {
        $map = array();
        $data = ' 1=1 ';
        //高级查询
        if ($request['md']) {
            $map['md'] = $request['md'];
            $data.=' AND md ="' . $request['md'] . '" ';
        }
        $perpage = C('FX_PERPAGE'); //每页行数
        $zijian = SM('Url');
        $count = $zijian->selectCount(
                $data, 'id'
        ); // 查询满足要求的总记录数
        // 进行分页数据查询 注意limit方法的参数要使用Page类的属性
        $page = page($count, $request['p'], $perpage) . ',' . $perpage;

        $list = $zijian->pageData(
                '*', $data, 'id DESC', $page
        );

        foreach ($list as $i => $iList) {
            $list[$i]['addtime'] = stringChange('formatDateTime', $iList['addtime']);
        }

        $pageList = $this->pageList($count, $perpage, $map);

        $params = array(
            'list' => $list,
            'page' => $pageList,
            'pageName' => $this->moduleName . '管理'
        );
        return [1,
            $params];
    }

    /**
     * 添加
     */
    public function add($request) {
        return [0,'暂不提供'];
    }

    /**
     * 修改
     */
    public function edit($request) {
        if (!$request['id']) {
            return [0,
                '参数错误！'];
        }
        $zijianModel = SM('Url');
        $row = $zijianModel->findData('*', 'id=' . $request['id']);
        $row['content']=unserialize($row['content']);
        $http=$row['content']['url'];
        $http=explode('/',$http);
        $row['http']=$http[0].'//'.$http[2].'/z/'.$row['md'];

        $params = array(
            'edit' => $row,
            'act' => 'edit',
            'pageName' => '修改' . $this->moduleName
        );
        return [1,
            $params,
            'Shorturl/add'];
    }

    /**
     * 保存
     */
    public function save($request) {
        return [0,'暂不提供'];
    }

    /**
     * 删除
     */
    public function delete($request) {
        $zijianID = $request['id']; //获取数据标识
        $idArray = explode(',', $zijianID);

        $clear = $request['clear']; //获取数据标识
        //清除三天以上的未支付订单
        if ($clear) {
            if (SM('Url')->deleteData('addtime<' . (time() - 3 * 24 * 3600) . '') === false) {
                return [
                    0,
                    '删除失败'];
            } else {
                //写入日志
                $this->adminLog($this->moduleName, '删除短连接3天以上的数据');
                return [
                    1,
                    '删除成功',
                    __URL__];
            }
        }

        if (!$zijianID) {
            return [0,
                '数据标识不能为空',
                __URL__];
        }
        if (SM('Url')->deleteData(
                        'id in (' . implode(',', $idArray) . ')') === false) {
            return [0,
                '删除失败'];
        } else {
            //写入日志
            $this->adminLog($this->moduleName, '删除短连接ID为【' . implode(',', $idArray) . '】的数据');
            return [1,
                '删除成功',
                __URL__];
        }
    }

}
