<?php

// +----------------------------------------------------------------------
// | easy pay [ pay to easy ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016-2019 All rights reserved.
// +----------------------------------------------------------------------
// | Author: fengxing <QQ:51125330>
// +----------------------------------------------------------------------

namespace Index\Controller;

use Common\Controller\DefaultController;

class BaseController extends DefaultController {

    protected $templateIndex = 'auto';

    public function __construct() {
        parent::__construct();
        $this->initial();
    }

    private function initial() {
        global $publicData;
        $peizhi = $publicData['peizhi'];

        //网站关闭
        if ($peizhi['closeweb'] == 1) {
            exit('网站关闭。');
        }

        //ip限制
        if ($peizhi['accessip'] > 0) {
            $nowIp = get_client_ip(0, true);
            $buffer = SM('Ip')->findData('*', 'ip="' . ip2long($nowIp) . '"');

            if ($buffer) {
                if ($buffer['status'] == 3)
                    exit('禁止访问');

                if ($peizhi['accessip'] == 2 && $buffer['status'] == 2)
                    exit('禁止访问');

                if ($peizhi['accessip'] == 1 && $buffer['status'] != 1 && $buffer['status'] != 4)
                    exit('禁止访问');
            }else {
                //白名单机制
                if ($peizhi['accessip'] == 1)
                    exit('禁止访问');
            }
        }

        //apihttp如果与本站网址不一致对非支付接口页面进行跳转
        if (!empty($peizhi['apihttp'])) {
            if ($_SERVER['HTTP_HOST'] == $peizhi['apihttp'] && !empty($peizhi['apijump'])) {
                if (strtolower(CONTROLLER_NAME) != 'pay' && strtolower(ACTION_NAME) != 'qrcode') {
                    if (empty($peizhi['apijump']))
                        $peizhi['apijump'] = 'http://www.baidu.com';
                    header('location:' . $peizhi['apijump']);
                    exit();
                }
            }elseif ($_SERVER['HTTP_HOST'] != $peizhi['apihttp']) {
                if (strtolower(CONTROLLER_NAME) == 'pay' && strtolower(ACTION_NAME) == 'index') {
                    if (empty($peizhi['apijump']))
                        $peizhi['apijump'] = 'http://www.baidu.com';
                    header('location:' . $peizhi['apijump']);
                    exit();
                }
            }
        }

        //处理模板 cookie优先
        if ($peizhi['templatecookie'] == 1) {
            $templatename = cookie('templatenow');
        } else {
            $templatename = $peizhi['template'];
        }
        $this->templateIndex = $templatename;
        $alltemplate = SL('Param')->template;
        if ($templatename == 'auto' || empty($alltemplate[$templatename])) {
            $this->templateIndex = '';
        }

        //检测用户登录
        if (CONTROLLER_NAME == 'Home' || ACTION_NAME == 'upload') {
            $checklogin = SL('User')->checklogin();
            $nowAction = MODULE_NAME . '/' . CONTROLLER_NAME . '/' . ACTION_NAME;
            if ($checklogin[0] == 0) {
                if (IS_AJAX) {
                    $this->reback([
                        0,
                        '请登录。',
                        U('/')]);
                } else {
                    header('Location:' . U('/'));
                }
                exit();
            }
            if (empty($publicData['user'])) {
                $publicData['user'] = $checklogin[1];
            }

            //认证未通过
            if ($peizhi['ifopenusercheck'] == 1 && $checklogin[1]['ifusercheck'] != 2 && ('info' != ACTION_NAME && 'loginout' != ACTION_NAME && 'upload' != ACTION_NAME)) {
                exit('<script>location.href="' . $publicData['peizhi']['httpstyle'] . '://' . $_SERVER['HTTP_HOST'] . U('Index/Home/info') . '";</script>');
                exit();
            }
        }


        $this->assign('config', $peizhi);
        $this->assign('sitename', $peizhi['sitename']);
        $this->assign('user', $checklogin[1]);
    }

}
