<?php

namespace Index\Controller;

class MerchantController extends BaseController
{

    protected $merchant;

    public function __construct()
    {
        parent::__construct();
        global $publicData;

        $prefix = $publicData['peizhi']['httpstyle'];
        $fxid = $_REQUEST['fxid'];

        if(empty($fxid) || !in_array($fxid, array('2019100','2019101','2019102'))){
            exit('参数错误，请输入商户号');
        }

        $this->merchant = array(
            'notifyUrl'=> $prefix. '://' . $_SERVER['HTTP_HOST'] . "/Test/notifyUrl",
            'backUrl'  => $prefix. '://' . $_SERVER['HTTP_HOST'] . "/Merchant/backUrl",
            'fxid'     => $fxid,
            'fxgetway' => $prefix . '://' . $publicData['peizhi']['apihttp'] . "/Pay",
        );

        $userBuffer = SM('User')->findData('userid,miyao', 'userid="' . $this->merchant['fxid'] . '"');
        $this->merchant['fxid'] = $userBuffer['userid'];
        $this->merchant['fxkey'] = $userBuffer['miyao'];
    }


    public function index()
    {
        if (!IS_POST) {
			$this->assign('id', $this->merchant['fxid']);
            $this->display();
            exit();
        }

        $fxfee = floatval($_REQUEST['fxfee']);

        if($fxfee < 1)
            $this->reback([0, '付款金额不能小于1元']);

        if($fxfee > 5000)
            $this->reback([0, '付款金额不能大于5000元']);


        $ddh = time() . getDingdanRand();
        $fxdesc = $this->merchant['fxid'] . '|' . $ddh . '|'. $fxfee;

        $data = array(
            "fxid" => $this->merchant['fxid'],
            "fxddh" => $ddh,
            "fxdesc" => $fxdesc,
            "fxfee" => $fxfee,
            "fxnotifyurl" => $this->merchant['notifyUrl'],
            "fxbackurl" => $this->merchant['backUrl'],
            "fxpay" => 'zfbpc',
            "fxip" => get_client_ip(0, true),
            'fxbankcode' => '',
            'fxfs' => '',
        );
        $data["fxsign"] = md5($data["fxid"] . $data["fxddh"] . $data["fxfee"] . $data["fxnotifyurl"] . $this->merchant['fxkey']);

        $r = curl($this->merchant['fxgetway'], $data);
        $backr = json_decode($r, true);
        if ($backr["status"] == 1) {
            $return = [1, $backr["payurl"]];
        } else {
            $return = !empty($backr["error"]) ? [0, $backr["error"]] : [0, $r];
        }
        $this->reback($return);
    }


    public function backUrl()
    {
        session_start();
        $fxid    = $_REQUEST['fxid'];   //商户编号
        $fxddh   = $_REQUEST['fxddh'];  //商户订单号
        $fxfee   = $_REQUEST['fxfee'];  //交易金额
        $fxstatus= $_REQUEST['fxstatus'];//订单状态
        $fxsign  = $_REQUEST['fxsign']; //md5验证签名串

        $mysign  = md5($fxstatus . $fxid . $fxddh . $fxfee . $this->merchant['fxkey']); //验证签名

        if ($this->merchant['fxloaderror'] == 1)
            file_put_contents('./demo.txt', '同步：' . serialize($_REQUEST) . "\r\n", FILE_APPEND);


        $orderddh = $fxid . $fxddh;
        if (empty($orderddh))
            $orderddh = session('ddh'); //获取session订单号
        if (empty($fxddh))
            $fxddh = session('ddh'); //获取session订单号

        $buffer = SM('Dingdan')->findData('*', 'ordernum="' . $orderddh . '"');
        if (!$buffer) {
            $this->reback([
                0,
                '订单号不存在.']);
        }

        $result = 0;
        if ($fxsign == $mysign) {
            if ($fxstatus == '1' || $buffer['status'] >= 1) {
                $result = 1;
            }
        } else {
            //判断订单是否已经支付成功 如果不成功等待10秒刷新, 验证订单号是否支付成功
            if ($buffer['status'] == 1) { //支付成功
                //跳转到支付成功后的页面
                session('ddhft', NULL);
                $result = 1;
            }
        }

        if ($result != 1) {
            //支付失败等待刷新验证, 完善流程 刷新3次跳出刷新
            $ddhft = session('ddhft'); //订单刷新次数
            if (!empty($ddhft) && $ddhft > 2) {
                session('ddhft', NULL);
                $result = 0;
            } else {
                $ddhft = empty($ddhft) ? 1 : $ddhft + 1;
                session('ddhft', $ddhft);
                $result = 2;
            }
        }

        $this->assign('ddh', $fxddh);
        $this->assign('money', $buffer['totalmoney']);
        $this->assign('result', $result);
        $this->display('Merchant/result');
    }
}
